# ====================================================================
# Copyright (c) 1999 GlobeCom GCAB AB.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer. 
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#
# 3. All advertising materials mentioning features or use of this
#    software must display the following acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# 4. The names "GlobeCom Jukebox" and "GlobeCom" must not be used to
#    endorse or promote products derived from this software without
#    prior written permission. For written permission, please contact
#    hpj@globecom.net.
#
# 5. Products derived from this software may not be called "GlobeCom
#    Jukebox" nor may "GlobeCom" appear in their names without prior written
#    permission of the GlobeCom GCAB AB.
#
# 6. Redistributions of any form whatsoever must retain the following
#    acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# THIS SOFTWARE IS PROVIDED BY GLOBECOM GCAB AB ``AS IS'' AND ANY
# EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL GLOBECOM GCAB AB OR
# ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
# ====================================================================

use DBI;
use MPEG::MP3Info;
use File::Find ();

my $dbh=DBI->connect("dbi:mysql:database=$DBNAME",$DBUSER,$DBPASS) || die;

# Traverse desired filesystems

my $add=$dbh->prepare("insert into songs (artist,title,volume,file,played,voted,toplist,lastplayed,entered,format,trackno,volid) ".
		      "values (?,?,?,?,0,0,0,now(),now(),'mp3',?,?)");
my $dup=$dbh->prepare("select count(*) from songs where (upper(artist) = upper(?) and upper(title) = upper(?) and upper(volume) = upper(?)) or file = ?");
my $rip=$dbh->prepare("insert into ripqueue values (0,?,'mp3','analyse',?,?,?,?,0,'',?,NULL)");

my $vol=$dbh->prepare("select id,mounted from volumes where (flags&2)=2 and length(mounted)>1");
$vol->execute();
my %validVol;
while(my ($volid,$mount)=$vol->fetchrow_array()) {
    $validVol{$volid}=$mount;
}

sub addit {
    my ($name)=@_;
    my $info=get_mp3tag($name);
    my $artist=$info->{ARTIST};
    my $title=$info->{TITLE};
    my $album=$info->{ALBUM};
    my $trackno=$info->{TRACKNUM};

    while($name=~s/\/\.\//\//) {

    }

    if ($artist&&$title) {
	my $now=time;
	$dup->execute($artist,$title,$album,$name);
	my ($count)=$dup->fetchrow_array;
	if ($count==0) {

	    my $volid;
	    my $maxSiz=0;

	    for my $nvol (keys %validVol) {
		my $base=$validVol{$nvol};
		if (substr($name,0,length($base)) eq $base) {
		    if ($maxSiz<length($base)) {
			$maxSiz=length($base);
			$volid=$nvol;
			$name=substr($name,$maxSiz);
			$name=~s/^\///;
		    }
		}
	    }	    

	    print "$artist - $title - $album - ".$validVol{$volid}." - $name\n";
	    $add->execute($artist,$title,$album,$name,$trackno,$volid);
	    my $songid=$add->{'mysql_insertid'};
	    $rip->execute($songid,$artist,$title,$album,$name,$trackno);
	}
    }
    return 0;
}

my $pwd=`pwd`;
chomp($pwd);

push(@ARGV,$pwd)
    if (!@ARGV);

for my $a (@ARGV) {
    if ($a=~/^\//) {
	&File::Find::find({wanted => \&wanted, follow => 1},$a);
    } else {
	&File::Find::find({wanted => \&wanted, follow => 1},$pwd."/".$a);
    }
}

exit;
no strict;
sub wanted {
    /^.*\.[mM][pP]3$/ &&
	addit($File::Find::name);
}
