# ====================================================================
# Copyright (c) 1999 GlobeCom GCAB AB.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer. 
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#
# 3. All advertising materials mentioning features or use of this
#    software must display the following acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# 4. The names "GlobeCom Jukebox" and "GlobeCom" must not be used to
#    endorse or promote products derived from this software without
#    prior written permission. For written permission, please contact
#    hpj@globecom.net.
#
# 5. Products derived from this software may not be called "GlobeCom
#    Jukebox" nor may "GlobeCom" appear in their names without prior written
#    permission of the GlobeCom GCAB AB.
#
# 6. Redistributions of any form whatsoever must retain the following
#    acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# THIS SOFTWARE IS PROVIDED BY GLOBECOM GCAB AB ``AS IS'' AND ANY
# EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL GLOBECOM GCAB AB OR
# ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
# ====================================================================

exit
    if (!$NICE||!$ENCODER||$#ARGV!=2);

#$SIG{CHLD}='IGNORE';

my ($id,$infile,$outfile)=@ARGV;

use DBI;

my $dbh=DBI->connect("dbi:mysql:database=$DBNAME",$DBUSER,$DBPASS) || die;

sub fetchsetting {
    my $res=$dbh->prepare("select value from settings where name = ?");
    $res->execute($_[0]);
    my $ret;
    ($ret)=$res->fetchrow_array();
    return $ret;
}

my $speed=fetchsetting("ENCODING");
$speed=~s/[^0-9]//g;
$speed=128
    if (!$speed);

$|=1;
$/="\r";

my $lper=0;
my $done=0;

if ($ENCODER=~/xingmp3enc$/) {

    open(INPUT,"-|") || do {
	close(STDERR);
	open(STDERR, ">&STDOUT");
	exec ($NICE,"-n","19",$ENCODER,"-B","$speed",$infile,$outfile) || die "Couldn't encode $infile to mp3";
    };
    
    while(<INPUT>) {
	s/\r//;
	s/\n//;
	if (/(\d*)%/)
	{
	    if ($lper!=$1) {
		$lper=$1;
		print $1."%\n";
	    }
	}
	$done=1
	    if (/Total encoding time/);
    }
    
    close INPUT;
    if ($?||!$done) {
	my $exit=($?>>8);
	my $signal=($?&0xff);
	print STDERR "Something went wrong converting (Exit code $exit, signal $signal)\n";
	exit 2;
    }
} elsif ($ENCODER=~/lame$/) {
    open(INPUT,"-|") || do {
	open(STDERR,">&STDOUT");
	exec ($NICE,"-n","19",$ENCODER,"-b",$speed,$infile,$outfile) || die "Couldn't encode $infile to mp3";
    };

    while(<INPUT>) {
	if (/(\d+)\%/) {
	    if ($lper!=$1) {
		$lper=$1;
		print $1."%\n";
	    }
	}
    }
    
    close INPUT;
    if ($?) {
	my $exit=($?>>8);
	my $signal=($?&0xff);
	print STDERR "Something went wrong converting (Exit code $exit, signal $signal)\n";
	exit 2;
    }
} else {
    open(INPUT,"-|") || do {
	exec ($NICE,"-n","19",$ENCODER,-$speed,"-QUIT",$infile)
	    || die "Couldn't encode $infile to mp3";
    };

    while(<INPUT>) {
	if (/Status:\s*(\d+)\.\d+/) {
	    if ($lper!=$1) {
		$lper=$1;
		print $1."%\n";
	    }
	}
	$done=1
	    if (/Completed\./);
    }
    
    close INPUT;
    if ($?||!$done) {
	my $exit=($?>>8);
	my $signal=($?&0xff);
	print STDERR "Something went wrong converting (Exit code $exit, signal $signal)\n";
	exit 2;
    }
    
    my $actual;
    ($actual=$infile)=~s/\.[^\.]+$/\.mp3/;
    
    if ($actual ne $outfile) {
	system($MV,$actual,$outfile);
    }
}

$dbh->disconnect;

if (-e $infile) {
   unlink($infile);
}
print "$outfile\n";

exit 0;
