# ====================================================================
# Copyright (c) 1999 GlobeCom GCAB AB.  All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer. 
#
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in
#    the documentation and/or other materials provided with the
#    distribution.
#
# 3. All advertising materials mentioning features or use of this
#    software must display the following acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# 4. The names "GlobeCom Jukebox" and "GlobeCom" must not be used to
#    endorse or promote products derived from this software without
#    prior written permission. For written permission, please contact
#    hpj@globecom.net.
#
# 5. Products derived from this software may not be called "GlobeCom
#    Jukebox" nor may "GlobeCom" appear in their names without prior written
#    permission of the GlobeCom GCAB AB.
#
# 6. Redistributions of any form whatsoever must retain the following
#    acknowledgment:
#    "This product includes software developed by GlobeCom GCAB AB
#    <http://www.globecom.net/> for use in GlobeCom Jukebox."
#
# THIS SOFTWARE IS PROVIDED BY GLOBECOM GCAB AB ``AS IS'' AND ANY
# EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL GLOBECOM GCAB AB OR
# ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
# LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
# ====================================================================

exit
    if (@ARGV!=3);

use Socket;
use MIME::Base64;
use DBI;

my ($id,$host)=@ARGV;

my ($artist,$title,$album,$filename,$trackno,$format);

{
    my $dbh=DBI->connect("dbi:mysql:database=$DBNAME",$DBUSER,$DBPASS) || die;
    {
	my $res=$dbh->prepare("select songid,artist,title,album,trackno,fromid from ripqueue where id=?");
	$res->execute($id);
	my $songid;
	($songid,$artist,$title,$album,$trackno,$format)=$res->fetchrow_array();
	$res=$dbh->prepare("select file from songs where id = ?");
	$res->execute($songid);
	($filename)=$res->fetchrow_array();
	if (!-f $filename) {
	    print "File $filename not found\n";
	    exit 1;
	}
    }
    $dbh->disconnect;
}

sub ReqFld {
    my ($bound,$nam,$val)=@_;
    return "--$bound\r\nContent-Disposition: form-data; name=\"$nam\"\r\n\r\n$val\r\n";
}

sub Req {
    my ($site,$artist,$title,$album,$trackno,$format,$filename)=@_;
    my @req;

    my ($user,$pwd,$host,$port,$path)=($site=~/^http:\/\/(?:(?:([^:]+):)?([^\@]+)\@)?([^\/:\@:]+)(?::(\d+))?(\/.*)$/);

    if (!$user) {
	$user=$pwd;
	$pwd="";
    }

    if (!$host) {
	print STDERR "Couldn't resolve host and path from URL $site\n";
	exit 2;
    }

    if (!$port) {
	$port=80;
    }

    if ($path!~/\/$/) {
	$path.="/";
    }

    $path.="action.php3";

    srand(time);

    my $bound="---------------------------".
	int(rand(100000000)).int(rand(100000000)).int(rand(100000000));

    my $auth=encode_base64($user.":".$pwd);
    $auth=~s/\s+$//;

    my $head="POST $path HTTP/1.0\r\n";
    $head.="User-Agent: GlobeCom Jukebox Uploader\r\n";
    $head.="Host: $host\r\n";
    $head.="Authorization: Basic $auth\r\n";
    $head.="Content-type: multipart/form-data; boundary=$bound\r\n";

    my $body=&ReqFld($bound,"ACTION","add");
    $body.=&ReqFld($bound,"ARTIST",$artist);
    $body.=&ReqFld($bound,"SONG",$title);
    $body.=&ReqFld($bound,"VOLUME",$album);
    $body.=&ReqFld($bound,"TRACKNO",$trackno);
    $body.=&ReqFld($bound,"FORMAT",$format);
    $body.="--$bound\r\n";
    $body.="Content-Disposition: form-data; name=\"UPLOAD\"; filename=\"whatever.mp3\"\r\n";
    $body.="Content-Type: audio/mpeg\r\n\r\n";

    my $foot.="\r\n--$bound--\r\n";

    my ($dev,$ino,$mode,$nlink,$uid,$gid,$rdev,$size,
     $atime,$mtime,$ctime,$blksize,$blocks)
	= stat($filename);
    
    if (!$size) {
	print STDERR "File $filename is missing or of 0 size\n";
	exit 2;
    }

    my $length=length($body)+length($foot)+$size;

    $head.="Content-Length: $length\r\n\r\n";

    if (!open (IN,"<$filename")) {
	print STDERR "Couldn't open $filename for reading\n";
	exit 2;
    }

    my $iaddr   = inet_aton($host)               || die "no host: $host";
    my $paddr   = sockaddr_in($port, $iaddr);

    my $proto   = getprotobyname('tcp');
    socket(SOCK, PF_INET, SOCK_STREAM, $proto)  || die "socket: $!";
    connect(SOCK, $paddr) || die "connect: $!";

    alarm(60);  # Bug out if nothing has happend in a minute
    print SOCK $head;
    print SOCK $body;

    my $data;

    my $BUFSIZE=1024;

    my $cursize=0;

    my $lp=0;

    $|=1;
    while(sysread(IN,$data,$BUFSIZE)>0) {
	alarm(60);  # Bug out if nothing has happend in a minute
	print SOCK $data;
	$cursize+=$BUFSIZE;
	my $cp=int(100*$cursize/$size);
	if ($cp!=$lp) {
	    print $cp."%\n";
	    $lp=$cp;
	}
    }
    close IN;

    print SOCK $foot;

    select SOCK; # Need to flush before being able to read;
    $|=1;
    select STDOUT;

    alarm(60);  # Bug out if nothing has happend in a minute
    $_=<SOCK>;

    if (!/^HTTP\/\d+\.\d+ 302/) {
	print;
	while(<SOCK>) {
	    print;
	}
	print "Wrong return from sending HTTP request, expected 302\n";
	exit 2;
    }

    close SOCK;
}

&Req($host,$artist,$title,$album,$trackno,$format,$filename);
