/* ====================================================================
 * Copyright (c) 1999 GlobeCom GCAB AB.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer. 
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *
 * 3. All advertising materials mentioning features or use of this
 *    software must display the following acknowledgment:
 *    "This product includes software developed by GlobeCom GCAB AB
 *    <http://www.globecom.net/> for use in GlobeCom Jukebox."
 *
 * 4. The names "GlobeCom Jukebox" and "GlobeCom" must not be used to
 *    endorse or promote products derived from this software without
 *    prior written permission. For written permission, please contact
 *    hpj@globecom.net.
 *
 * 5. Products derived from this software may not be called "GlobeCom
 *    Jukebox" nor may "GlobeCom" appear in their names without prior written
 *    permission of the GlobeCom GCAB AB.
 *
 * 6. Redistributions of any form whatsoever must retain the following
 *    acknowledgment:
 *    "This product includes software developed by GlobeCom GCAB AB
 *    <http://www.globecom.net/> for use in GlobeCom Jukebox."
 *
 * 7. The software cannot be redistributed or used for commercial purposes
 *    without a license from MpegTV, LLC <http://www.xaudio.com/>
 *
 * THIS SOFTWARE IS PROVIDED BY GLOBECOM GCAB AB ``AS IS'' AND ANY
 * EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL GLOBECOM GCAB AB OR
 * ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 * ====================================================================
 */

#include <stdio.h>
#include <unistd.h>

#define BUFFER_SIZE 16384
#define HIST_SIZE 16
#define SKIP_SIZE 256
typedef short datatype;

int main(void)
{
  datatype c[BUFFER_SIZE];
  int history[HIST_SIZE];
  int len,i,num,count=0;
  for (i=0;i<HIST_SIZE;i++)
    history[i]=0;
  while((len=fread(c,sizeof(datatype),BUFFER_SIZE,stdin))>0) {
    for (i=0;i<len;i++) {
      if (abs(c[i])>SKIP_SIZE) {
	history[abs(c[i])/(32768/HIST_SIZE)]++;
	count++;
#if 0
	if (count%441000==0)
	  write(1,".",1);
#endif
      }
    }
  }
#if 0
  printf("\n");
  for (i=0;i<HIST_SIZE-1;i++) {
    printf("%d ",history[i]);
  }
#endif
  for (i=HIST_SIZE-1;i>=0;i--) {
    num+=history[i];
    if (num>count/10) {
      printf("%d\n",i);
      exit(0);
    }
  }
  printf("\n0\n");
  exit(1);
}
